import processing.video.*;  

Movie movie;

PImage[] tampons;
int nbLogo = 0;
int compteur = 0;
int largeur, hauteur, nbPix;

int xLogo, yLogo;
color couleur;
PImage image;

void setup() {

  movie = new Movie(this, "tst.mp4");
  movie.play();

  largeur = 960;
  hauteur = 540;
  nbPix= largeur*hauteur;  

  tampons = new PImage[8];
  for (int i=0; i<tampons.length; i++) {
    tampons[i] = loadImage(str(i)+"c.png");
  }
  size(largeur, hauteur*2);
  frameRate(25);

  background(0);
}

void draw() {

  if (movie.available() == true) {
    movie.jump((frameCount+35+ 0.5)*0.04);
    movie.read();
  }

  tint(255);
  image(movie, 0, hauteur);
  loadPixels();

  for (int i=0; i<nbLogo; i++) {
    dessine();
  }

  if (frameCount%15 == 0 && nbLogo<1000) nbLogo += 5;

  get(0, 0, 960, 540).save("pix/"+num(frameCount)+".png");
}


// dessine les logos à la place des pixels
void dessine() {

  // choisi les coordonnées d'un pixel 
  // dans la partie inférieure de la scène 
  xLogo = int(random(width-1));
  yLogo = int(random(height/2-1));

  // récupère la couleur de ce pixel
  couleur = pixels[nbPix+xLogo+yLogo*width];

  // applique cette couleur au logo et le dessine
  
  tint(couleur);
  image(tampons[compteur%8], xLogo-15, yLogo-15);
  
  compteur++;
}


// Pour avoir des fichiers numérotés à 4 chiffres
String num(int valeur) {

  if (valeur < 10 ) return "000"+str(valeur);
  if (valeur >= 10 && valeur < 100) return "00"+str(valeur);
  if (valeur >= 100 && valeur < 1000) return "0"+str(valeur);
  else return str(valeur);
}
